package main;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import xpctest.TestBean;

public class Main {
	public static void main(String[] args) throws Exception
	{
		Context ctx = new InitialContext();
        
		TestBean testXPCSFSB1a = (TestBean)ctx.lookup("xpc-jbas51/TestXPCSFSB1/remote-xpctest.TestBean");
		TestBean testXPCSFSB1b = (TestBean)ctx.lookup("xpc-jbas51/TestXPCSFSB1/remote-xpctest.TestBean");
		TestBean testXPCSFSB2a = (TestBean)ctx.lookup("xpc-jbas51/TestXPCSFSB2/remote-xpctest.TestBean");
		TestBean testXPCSFSB2b = (TestBean)ctx.lookup("xpc-jbas51/TestXPCSFSB2/remote-xpctest.TestBean");
	    TestBean testTPCSFSB1a = (TestBean)ctx.lookup("xpc-jbas51/TestTPCSFSB1/remote-xpctest.TestBean");
	    TestBean testTPCSFSB1b = (TestBean)ctx.lookup("xpc-jbas51/TestTPCSFSB1/remote-xpctest.TestBean");
	    TestBean testTPCSFSB2a = (TestBean)ctx.lookup("xpc-jbas51/TestTPCSFSB2/remote-xpctest.TestBean");
	    TestBean testTPCSFSB2b = (TestBean)ctx.lookup("xpc-jbas51/TestTPCSFSB2/remote-xpctest.TestBean");
	    TestBean testSLSB1a = (TestBean)ctx.lookup("xpc-jbas51/TestSLSB1/remote-xpctest.TestBean");
	    TestBean testSLSB1b = (TestBean)ctx.lookup("xpc-jbas51/TestSLSB1/remote-xpctest.TestBean");
	    TestBean testSLSB2a = (TestBean)ctx.lookup("xpc-jbas51/TestSLSB2/remote-xpctest.TestBean");
	    TestBean testSLSB2b = (TestBean)ctx.lookup("xpc-jbas51/TestSLSB2/remote-xpctest.TestBean");
		
	    // first, without user transaction
	    System.out.println("Test without user transaction");
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    System.out.println(testXPCSFSB2b.helloWorld("testXPCSFSB2b"));

	    // now the same, but with user transaction
        UserTransaction ut = (UserTransaction)ctx.lookup("UserTransaction");

	    ut.begin();
					
	    System.out.println("\nTest with user transaction " + ut);
	    System.out.println(testSLSB1a.helloWorld("testSLSB1a"));
	    System.out.println(testSLSB1b.helloWorld("testSLSB1b"));
	    System.out.println(testSLSB2a.helloWorld("testSLSB2a"));
	    System.out.println(testSLSB2b.helloWorld("testSLSB2b"));
	    System.out.println(testTPCSFSB1a.helloWorld("testTPCSFSB1a"));
	    System.out.println(testTPCSFSB1b.helloWorld("testTPCSFSB1b"));
	    System.out.println(testTPCSFSB2a.helloWorld("testTPCSFSB2a"));
	    System.out.println(testTPCSFSB2b.helloWorld("testTPCSFSB2b"));
	    System.out.println(testXPCSFSB1a.helloWorld("testXPCSFSB1a"));
	    System.out.println(testXPCSFSB1b.helloWorld("testXPCSFSB1b"));
	    System.out.println(testXPCSFSB2a.helloWorld("testXPCSFSB2a"));
	    System.out.println(testXPCSFSB2b.helloWorld("testXPCSFSB2b"));

	    ut.rollback();
	    
	    ctx.close();
	}
}